/*
	Genetic Algorithm Simulation for TalesWeaver
	Core Module
*/
////////////////////////////////////////////////////////////////////////

#include "../common/stdafx.h"
#include "GAcore.h"

////////////////////////////////////////////////////////////////////////
// GAC֐

// ϐ̊S
void CGAcore::initialize()
{
	m_proc_loop_main  = 0;
	m_proc_loop_gene  = 0;
	m_proc_score      = 0;
	m_proc_time       = 0;
	for (int i=0; i<NUM_STAT; i++) {
		m_proc_stat[i] = 0;
		m_proc_smin[i] = D_STAT_MIN[i];
		m_proc_smax[i] = D_STAT_MAX[i];
	}
	m_proc_isdone = false;
	m_proc_modify = false;
	m_proc_cancel = false;
}

void CGAcore::initialize(CGAparam &gaparam)
{
	m_param = &gaparam;
	CGAunit::m_param = &gaparam;
	m_param->initialize();
	initialize();
}

// p[^`FbN
bool CGAcore::validate(char *errmsg)
{
	if (!m_param->validate(errmsg)) return false;

	return true;
}

// GAGg|Cg
void CGAcore::genetic_entrypoint(CGAunit &unit_in, CGAunit &unit_out, bool use_unit_in)
{
	rand_init();
	if (use_unit_in) unit_in.eval(true);

	CGAunit *unit_list1 = new CGAunit[m_param->m_ga_unit_total];
	CGAunit *unit_list2 = new CGAunit[m_param->m_ga_unit_total];

	int unit_num = 0;
	if (m_param->m_ga_try_time == 1) {
		// 1̂ݎs
		m_proc_loop_main = 0;
		genetic_init_list(unit_num, unit_list1, unit_in, use_unit_in);
		genetic_main(unit_list1);
	} else {
		// N-1ssAꂼłKx̍̂ŏIǐ̂ƂčĎs
		for (m_proc_loop_main=0; m_proc_loop_main<m_param->m_ga_try_time-1; m_proc_loop_main++) {
			int tmp = 0;
			genetic_init_list(tmp, unit_list2, unit_in, use_unit_in);
			genetic_main(unit_list2);
			genetic_add_unique(unit_num, unit_list1, unit_list2[0]);
		}
		genetic_init_list(unit_num, unit_list1, unit_in, false);
		genetic_main(unit_list1);
	}

	unit_out = unit_list1[0];
	unit_out.eval(true);
	delete [] unit_list1;
	delete [] unit_list2;

	m_param->m_proc_time = m_proc_time;
	m_proc_isdone = true;
}

// GA
void CGAcore::genetic_main(CGAunit *unit_list)
{
	if (m_proc_cancel) return;

	CGAunit unit_best = unit_list[0];
	CGAunit *unit_next = new CGAunit[m_param->m_ga_unit_total];
	int *unit_score = new int[m_param->m_ga_unit_total];
	int *unit_index = new int[m_param->m_ga_unit_total];
	m_proc_score = 0x80000000;

	// ԑJn
	struct timeb tb1;
	ftime(&tb1);

	// ニ[v
	bool last_updated = true;
	for (m_proc_loop_gene=0; m_proc_loop_gene<m_param->m_ga_generation; m_proc_loop_gene++) {
		// 쐧
		if (m_proc_modify) {
			m_proc_modify = false;
			m_proc_score = 0x80000000;
			m_param->initialize_stat_minmax(m_proc_smin, m_proc_smax);
		}
		if (m_proc_cancel) break;
		// Kx]
		for (int i=0; i<m_param->m_ga_unit_total; i++) {
			unit_score[i] = unit_list[i].eval(last_updated && i == 0);
			unit_index[i] = i;
		}
		// \[g
		for (int j=m_param->m_ga_unit_total-1; j>0; j--) {
			for (int i=0; i<j; i++) {
				if (unit_score[i] < unit_score[i+1]) {
					swap(unit_score[i], unit_score[i+1]);
					swap(unit_index[i], unit_index[i+1]);
				}
			}
		}
		// oߕ\
		int progress1 =  m_proc_loop_gene      * 100 / m_param->m_ga_generation;
		int progress0 = (m_proc_loop_gene - 1) * 100 / m_param->m_ga_generation;
		if (progress1 != progress0) {
			PRINTF(("[%2d%%]\r", progress1));
		}
		// KxXV
		last_updated = m_proc_score < unit_score[0];
		if (last_updated) {
			m_proc_score = unit_score[0];
			unit_best = unit_list[unit_index[0]];
			for (int i=0; i<NUM_STAT; i++) m_proc_stat[i] = unit_best.m_stat[i] / 100;
			PRINTF(("[%2d%%] loop = %6d update score = %d\n", progress1, m_proc_loop_gene, m_proc_score));
		}
		// G[gI
		int unit_num = 0;
		CGAunit unit_new;
		for (int i=0; i<m_param->m_ga_unit_elite; i++) {
			unit_new = unit_list[unit_index[i]];
//			unit_new.eval();
			if (!genetic_add_unique(unit_num, unit_next, unit_new)) i--;
		}
		// _
		for (int i=0; i<m_param->m_ga_unit_twice; i++) {
			int u1 = unit_index[rand_rank()];
			int u2 = unit_index[rand_rank()];
			unit_new.genom_twice(unit_list[u1], unit_list[u2]);
//			unit_new.eval();
			if (!genetic_add_unique(unit_num, unit_next, unit_new)) i--;
		}
		// l
		for (int i=0; i<m_param->m_ga_unit_unif; i++) {
			int u1 = unit_index[rand_rank()];
			int u2 = unit_index[rand_rank()];
			unit_new.genom_unif(unit_list[u1], unit_list[u2]);
//			unit_new.eval();
			if (!genetic_add_unique(unit_num, unit_next, unit_new)) i--;
		}
		// zu]
		for (int i=0; i<m_param->m_ga_unit_swap; i++) {
			int u = unit_index[rand_rank()];
			unit_new.genom_swap(unit_list[u]);
//			unit_new.eval();
			if (!genetic_add_unique(unit_num, unit_next, unit_new)) i--;
		}
		// 
		for (int i=0; i<m_param->m_ga_unit_total; i++) unit_list[i] = unit_next[i];
	}

	// ԑI
	struct timeb tb2;
	ftime(&tb2);
	m_proc_time += ((int)tb2.time - (int)tb1.time) * 1000 + ((int)tb2.millitm - (int)tb1.millitm);

	// ōXRÄ`qœK\[g
	genetic_sort(unit_best, unit_list[0]);

	delete [] unit_next;
	delete [] unit_score;
	delete [] unit_index;
}

// `q쐬
void CGAcore::genetic_init_list(int &unit_num, CGAunit *unit_list, CGAunit &unit_in, bool use_unit_in)
{
	if (use_unit_in) {
		genetic_add_unique(unit_num, unit_list, unit_in);
	}
	while (unit_num < m_param->m_ga_unit_total) {
		CGAunit unit_new;
		unit_new.genom_init();
		unit_new.eval(true);
		genetic_add_unique(unit_num, unit_list, unit_new);
	}
}

// dĂȂΈ`qXg֒ǉ
// unit_newevalς݂łȂĂǂ
bool CGAcore::genetic_add_unique(int &unit_num, CGAunit *unit_list, CGAunit &unit_new)
{
	for (int i=0; i<unit_num; i++) {
		if (unit_list[i] == unit_new) return false;
	}
	unit_list[unit_num++] = unit_new;
	return true;
}

// œK\[g
void CGAcore::genetic_sort(CGAunit &src, CGAunit &dst)
{
	if (m_proc_cancel) {
		dst = src;
		return;
	}

	CGAunit unit1;
	CGAunit unit2;

	// [h
	unit1 = src;

	while (1) {
		bool is_updated = false;

		// œK1 : Cӂ̈`vf2_ւ
LABEL_OPTIMIZE1:
		for (int i=D_LEVEL_START; i<=D_LEVEL_FINAL-1; i++) for (int j=i+1; j<=D_LEVEL_FINAL; j++) {
			// uz
			unit2 = unit1;
			unit2.genom_modify_swap_element(i, j);
			int score1 = unit1.eval();
			int score2 = unit2.eval();
			// r
			if (score1 < score2) {
				unit1 = unit2;
				m_proc_score = score2;
				PRINTF(("[---] sort1 %3d-%3d     update score = %d\n", i, j, score2));
				is_updated = true;
				goto LABEL_OPTIMIZE1;
			}
		}

		// œK2 : Cӂ̈`qA͈2ւ
LABEL_OPTIMIZE2:
		int vec_size;
		int vec_lv1[NUM_ELEM];
		int vec_lv2[NUM_ELEM];
		ETYPE vec_elem[NUM_ELEM];
		unit1.genomband_export(vec_size, vec_lv1, vec_lv2, vec_elem);
		for (int i=0; i<vec_size-1; i++) for (int j=i+1; j<vec_size; j++) {
			// uz
			unit2 = unit1;
			unit2.genom_modify_swap_band(vec_lv1[i], vec_lv2[i], vec_lv1[j], vec_lv2[j]);
			int score1 = unit1.eval();
			int score2 = unit2.eval();
			// r
			if (score1 < score2) {
				unit1 = unit2;
				m_proc_score = score2;
				PRINTF(("[---] sort2 %3d-%3d/%3d update score = %d\n", i, j, vec_size, score2));
				is_updated = true;
				goto LABEL_OPTIMIZE2;
			}
		}

		// ǂ̍œKʂȂȂI
		if (!is_updated) break;
	}

	// Z[u
	dst = unit1;
}

////////////////////////////////////////////////////////////////////////
// _֐

// _
void CGAcore::rand_init()
{
	unsigned int seed = m_param->m_opt_output_fix ? 0 : (unsigned int)time(NULL);
	init_gen_rand(seed);
	rand_bool(true);
}

// LOIp_
int CGAcore::rand_rank()
{
	return m_param->m_ga_rank_table[rand_range1(m_param->m_ga_rank_tsize)];
}
