/*
	Genetic Algorithm Simulation for TalesWeaver
	Log Import/Export Module
*/
////////////////////////////////////////////////////////////////////////

#include "../common/stdafx.h"
#include "GAimex.h"

#define D_UNIT_STAT       m_unit->m_stat
#define D_UNIT_POINT      m_unit->m_point
#define D_UNIT_B_STAT(i)  m_unit->m_backup_stat[i]
#define D_UNIT_B_POINT(i) m_unit->m_backup_point[i]

////////////////////////////////////////////////////////////////////////
// Oo͊֐()

// 
void GAimex::init(CGAparam &param, CGAunit &unit)
{
	m_param = &param;
	m_unit  = &unit;
}

// O͂`q֕ϊ
void GAimex::import_log(CGAparam &param, CGAunit &unit, char *log)
{
	int vec_size = 0;
	int vec_lv1[NUM_ELEM];
	int vec_lv2[NUM_ELEM];
	ETYPE vec_elem[NUM_ELEM];

	init(param, unit);
	imex_log2vec(vec_size, vec_lv1, vec_lv2, vec_elem, log);
	_fix_stat();
	m_unit->genomband_import(vec_size, vec_lv1, vec_lv2, vec_elem);
}

// `q񂩂烍Oo͂֕ϊ
void GAimex::export_log(CGAparam &param, CGAunit &unit, char *log)
{
	int vec_size;
	int vec_lv1[NUM_ELEM];
	int vec_lv2[NUM_ELEM];
	ETYPE vec_elem[NUM_ELEM];

	init(param, unit);
	m_unit->genomband_export(vec_size, vec_lv1, vec_lv2, vec_elem);
	log[0] = '\0';
	imex_vec2log(vec_size, vec_lv1, vec_lv2, vec_elem, log);
}

// K؂ȉsR[htprintfA
void GAimex::_strcat(char *log, char *format, ...)
{
	char str[1024];
	va_list args;
	va_start(args, format);
	vsprintf(str, format, args);
	va_end(args);

	strcat(log, str);
	strcat(log, EOL);
}

// 񂩂s擾
bool GAimex::_sgets(char *&pos, char *buf)
{
	while (*pos == '\0' || *pos == '\r' || *pos == '\n') {
		if (*pos == '\0') return false;
		pos++;
	}

	for (int i=0;; i++) if (pos[i] == '\0' || pos[i] == '\r' || pos[i] == '\n') {
		strncpy(buf, pos, i);
		buf[i] = '\0';
		pos += i;
		return true;
	}
}

// Xe[^X̗L
void GAimex::_fix_stat()
{
	for (int i=0; i<NUM_STAT; i++) {
		if (D_STAT_MIN[i] > 5) {
			D_STAT_MAX[i] = MAX_STATUS;
			D_STAT_WEI[i] = 1;
		} else {
			D_STAT_MIN[i] = 0;
			D_STAT_MAX[i] = 0;
			D_STAT_WEI[i] = 0;
		}
	}
}

////////////////////////////////////////////////////////////////////////
// Oo͊֐()

void GAimex_gasim::imex_vec2log(int &vec_size, int *vec_lv1, int *vec_lv2, ETYPE *vec_elem, char *log)
{
	int hmsw[NUM_HMSW * 5];
	int score = m_unit->eval(true, hmsw);

	_strcat(log, "%s", conv_idx2str_cstyle(D_STYLE));
	_strcat(log, "Lv     = %d",   D_LEVEL);
	_strcat(log, "Random = %d%%", D_OPT_RANDOM_RATE);
	_strcat(log, "------------------------------------------------------------");
	_strcat(log, "              |             |   S   H   I   F   M   X   A  P");
	for (int i=0; i<vec_size; i++) {
		_strcat(log, "Lv%3d - Lv%3d | %-6s %-4s | %3d %3d %3d %3d %3d %3d %3d %2d",
			vec_lv1[i],
			vec_lv2[i],
			conv_elem2str_xien(vec_elem[i]),
			conv_elem2str_stat(vec_elem[i]),
			D_UNIT_B_STAT(vec_lv2[i])[0] / 100,
			D_UNIT_B_STAT(vec_lv2[i])[1] / 100,
			D_UNIT_B_STAT(vec_lv2[i])[2] / 100,
			D_UNIT_B_STAT(vec_lv2[i])[3] / 100,
			D_UNIT_B_STAT(vec_lv2[i])[4] / 100,
			D_UNIT_B_STAT(vec_lv2[i])[5] / 100,
			D_UNIT_B_STAT(vec_lv2[i])[6] / 100,
			D_UNIT_B_POINT(vec_lv2[i])
		);
	}
	_strcat(log, "------------------------------------------------------------");
	for (int i=0; i<NUM_STAT; i++) {
		_strcat(log, "%-6s = %6.2f", conv_idx2str_stat(i), D_UNIT_STAT[i] / 100.0);
	}
	_strcat(log, "------------------------------------------------------------");
	_strcat(log, "Point  = %3d", D_UNIT_POINT);
	_strcat(log, "------------------------------------------------------------");
	_strcat(log, "HP     = %5d-%5d (99.99%%̊m%5d-%5d)  %5d", hmsw[ 0], hmsw[ 1], hmsw[ 2], hmsw[ 3], hmsw[ 4]);
	_strcat(log, "MP     = %5d-%5d (99.99%%̊m%5d-%5d)  %5d", hmsw[ 5], hmsw[ 6], hmsw[ 7], hmsw[ 8], hmsw[ 9]);
	_strcat(log, "SP     = %5d-%5d (99.99%%̊m%5d-%5d)  %5d", hmsw[10], hmsw[11], hmsw[12], hmsw[13], hmsw[14]);
	_strcat(log, "Weight = %5d-%5d (99.99%%̊m%5d-%5d)  %5d", hmsw[15], hmsw[16], hmsw[17], hmsw[18], hmsw[19]);
	_strcat(log, "------------------------------------------------------------");
	_strcat(log, "total time %.3f[s] avg time %.3f[ns] score = %d", D_TIME_MS_ALL / 1000.0, D_TIME_MS_GENOM * 1000000.0, score);
}

void GAimex_gasim::imex_log2vec(int &vec_size, int *vec_lv1, int *vec_lv2, ETYPE *vec_elem, char *log)
{
	char buf[1024];
	char cmd1[1024], cmd2[1024], cmd3[1024], cmd4[1024];
	int num_cmd;

	while (_sgets(log, buf)) {
		for (int i=0; i<(int)strlen(buf); i++) if (buf[i] == ',') buf[i] = ' ';
		num_cmd = sscanf(buf, "%s %s %s %s", cmd1, cmd2, cmd3, cmd4);
		DPRINTF(("[%d] %s\n", num_cmd, buf));
		if (num_cmd == 1 && cmd1[0] != '-') {
			D_STYLE = conv_str2idx(buf);
			D_CHARA = D_STYLE / NUM_STYLE;
			DPRINTF(("[#] chara  = %s\n", conv_idx2str_chara(D_CHARA)));
			DPRINTF(("[#] style  = %s\n", conv_idx2str_style(D_STYLE)));
		}
		if (num_cmd == 3 && !strcmp(cmd1, "Lv")) {
			D_LEVEL = atoi(cmd3);
			DPRINTF(("[#] level  = %d\n", D_LEVEL));
		}
		if (num_cmd == 3 && !strcmp(cmd1, "Random")) {
			D_OPT_RANDOM_RATE = atoi(cmd3);
			DPRINTF(("[#] random = %d\n", D_OPT_RANDOM_RATE));
		}
		for (int i=0; i<NUM_STAT; i++) if (num_cmd == 3 && !strcmp(cmd1, conv_idx2str_stat(i))) {
			D_STAT_MIN[conv_str2idx_stat(cmd1)] = atoi(cmd3);
			DPRINTF(("[#] %-4s   = %d\n", conv_idx2str_stat(conv_str2idx_stat(cmd1)), D_STAT_MIN[conv_str2idx_stat(cmd1)]));
		}
		if (num_cmd == 4 && !strncmp(cmd1, "Lv", 2)) {
			if (sscanf(buf, "Lv %s - Lv %s | Xien = %s | Status = %s", cmd1, cmd2, cmd3, cmd4) != 4 ) {
				sscanf(buf, "Lv %s - Lv %s | %s / %s",                 cmd1, cmd2, cmd3, cmd4);
			};
			vec_lv1 [vec_size] = atoi(cmd1);
			vec_lv2 [vec_size] = atoi(cmd2);
			vec_elem[vec_size] = conv_str2elem_xien(cmd3) | conv_str2elem_stat(cmd4);
			DPRINTF(("[#] assign = %d - %d : %s / %s\n", vec_lv1[vec_size], vec_lv2[vec_size], conv_elem2str_xien(vec_elem[vec_size]), conv_elem2str_stat(vec_elem[vec_size])));
			vec_size++;
			continue;
		}
	}
}

void GAimex_oresim::imex_vec2log(int &vec_size, int *vec_lv1, int *vec_lv2, ETYPE *vec_elem, char *log)
{
	char stat_buf1[1024];
	char stat_buf2[1024];
	stat_buf2[0] = '\0';
	for (int i=0; i<NUM_STAT; i++) {
		sprintf(stat_buf1, " %s %d", conv_idx2str_stat(i), D_UNIT_STAT[i] / 100);
		strcat(stat_buf2, stat_buf1);
	}

	_strcat(log, "LV   1       :");
	_strcat(log, "Bonus        : %d%%", D_OPT_RANDOM_RATE);
	for (int i=0; i<vec_size; i++) {
		if (!i || conv_elem2idx_xien(vec_elem[i]) != conv_elem2idx_xien(vec_elem[i-1])) {
			_strcat(log, "Xien         : %s %s/%s",
				conv_elem2str_xien(vec_elem[i]),
				conv_idx2str_stat(m_param->xien_up_fix(conv_elem2idx_xien(vec_elem[i]))),
				conv_idx2str_stat(m_param->xien_up_rnd(conv_elem2idx_xien(vec_elem[i])))
			);
		}
		if (vec_lv1[i] == vec_lv2[i]) _strcat(log, "LV %3d       : %s ɐU", vec_lv1[i],             conv_elem2str_stat(vec_elem[i]));
		else                          _strcat(log, "LV %3d - %3d : %s ɐU", vec_lv1[i], vec_lv2[i], conv_elem2str_stat(vec_elem[i]));
	}
	_strcat(log, "%s/%s Bonus: %d / %d Point: %d",
		conv_idx2str_chara(D_CHARA),
		conv_idx2str_style(D_STYLE),
		(D_LEVEL - 1) * D_OPT_RANDOM_RATE / 100,
		D_LEVEL - 1,
		D_UNIT_POINT
	);
	_strcat(log, "LV:%d%s", D_LEVEL, stat_buf2);
}

void GAimex_oresim::imex_log2vec(int &vec_size, int *vec_lv1, int *vec_lv2, ETYPE *vec_elem, char *log)
{
	char buf[1024];
	char cmd1[1024], cmd2[1024], cmd3[1024], cmd4[1024];
	int num_cmd;

	ETYPE xien = 0;
	while (_sgets(log, buf)) {
		for (int i=0; i<(int)strlen(buf); i++) if (buf[i] == ',') buf[i] = ' ';
		num_cmd = sscanf(buf, "%s %s %s %s", cmd1, cmd2, cmd3, cmd4);
		DPRINTF(("[%d] %s\n", num_cmd, buf));
		if (num_cmd == 4 && !strcmp(cmd2, "Bonus:")) {
			if (!strstr(cmd1, "")) strcat(cmd1, "^");
			D_STYLE = conv_str2idx(cmd1);
			D_CHARA = D_STYLE / NUM_STYLE;
			DPRINTF(("[#] chara  = %s\n", conv_idx2str_chara(D_CHARA)));
			DPRINTF(("[#] style  = %s\n", conv_idx2str_style(D_STYLE)));
		} else if (num_cmd == 4 && !strcmp(cmd2, "STAB")) {
			sscanf(buf, "LV:%d STAB %d HACK %d INT %d DEF %d MR %d DEX %d AGI %d",
				&D_LEVEL,
				&D_STAT_MIN[0], &D_STAT_MIN[1], &D_STAT_MIN[2], &D_STAT_MIN[3], &D_STAT_MIN[4], &D_STAT_MIN[5], &D_STAT_MIN[6]
			);
			DPRINTF(("[#] level  = %d\n", D_LEVEL));
			for (int i=0; i<NUM_STAT; i++) DPRINTF(("[#] %-4s   = %d\n", conv_idx2str_stat(i), D_STAT_MIN[i]));
		} else if (num_cmd == 3 && !strcmp(cmd1, "Bonus")) {
			D_OPT_RANDOM_RATE = atoi(cmd3);
			DPRINTF(("[#] random = %d\n", D_OPT_RANDOM_RATE));
		} else if (num_cmd == 4 && !strcmp(cmd1, "Xien")) {
			xien = conv_str2elem_xien(cmd3);
		} else if (num_cmd == 4 && !strcmp(cmd1, "LV")) {
			if        (sscanf(buf, "LV %s : %s",      cmd1,       cmd3) == 2) {
				strcpy(cmd2, cmd1);
			} else if (sscanf(buf, "LV %s - %s : %s", cmd1, cmd2, cmd3) != 3) {
				continue;
			}
			vec_lv1 [vec_size] = atoi(cmd1);
			vec_lv2 [vec_size] = atoi(cmd2);
			vec_elem[vec_size] = xien | conv_str2elem_stat(cmd3);
			DPRINTF(("[#] assign = %d - %d : %s / %s\n", vec_lv1[vec_size], vec_lv2[vec_size], conv_elem2str_xien(vec_elem[vec_size]), conv_elem2str_stat(vec_elem[vec_size])));
			vec_size++;
			continue;
		}
	}
}

void GAimex_saibunpai::imex_vec2log(int &vec_size, int *vec_lv1, int *vec_lv2, ETYPE *vec_elem, char *log)
{
	char *stat_char_list = "SHIFMXA";
	char stat_buf1[1024];
	char stat_buf2[1024];
	stat_buf2[0] = '\0';
	for (int i=0; i<NUM_STAT; i++) {
		sprintf(stat_buf1, ",%c%d", stat_char_list[i], D_UNIT_STAT[i] / 100);
		strcat(stat_buf2, stat_buf1);
	}

	_strcat(log, "[ %s / %s ]", conv_idx2str_chara(D_CHARA), conv_idx2str_style(D_STYLE));
	for (int i=0; i<vec_size; i++) {
		if (!i || conv_elem2idx_xien(vec_elem[i]) != conv_elem2idx_xien(vec_elem[i-1])) {
			_strcat(log, "[ n: %s /_: %d %% ](Lv%d->%d)",
				conv_elem2str_xien(vec_elem[i]),
				D_OPT_RANDOM_RATE,
				vec_lv1[i] - 1,
				vec_lv1[i]
			);
		}
		_strcat(log, "\ %c l %d (Lv%d)܂ŏグ",
			stat_char_list[conv_elem2idx_stat(vec_elem[i])],
			D_UNIT_B_STAT(vec_lv2[i])[conv_elem2idx_stat(vec_elem[i])] / 100,
			vec_lv2[i]
		);
	}
	_strcat(log, "L%d%s,P%d,R%d/%d",
		D_LEVEL,
		stat_buf2,
		D_UNIT_POINT,
		(D_LEVEL - 1) * D_OPT_RANDOM_RATE / 100,
		D_LEVEL - 1
	);
}

void GAimex_saibunpai::imex_log2vec(int &vec_size, int *vec_lv1, int *vec_lv2, ETYPE *vec_elem, char *log)
{
	char buf[1024];
	char cmd1[1024], cmd2[1024], cmd3[1024], cmd4[1024];
	int num_cmd;

	ETYPE xien = 0;
	while (_sgets(log, buf)) {
		for (int i=0; i<(int)strlen(buf); i++) if (buf[i] == ',') buf[i] = ' ';
		num_cmd = sscanf(buf, "%s %s %s %s", cmd1, cmd2, cmd3, cmd4);
		DPRINTF(("[%d] %s\n", num_cmd, buf));
		if (num_cmd == 4 && !strcmp(cmd3, "/")) {
			sscanf(buf, "[ %s / %s ]", cmd1, cmd2);
			sprintf(cmd3, "%s/%s", cmd1, cmd2);
			D_STYLE = conv_str2idx(cmd3);
			D_CHARA = D_STYLE / NUM_STYLE;
			DPRINTF(("[#] chara  = %s\n", conv_idx2str_chara(D_CHARA)));
			DPRINTF(("[#] style  = %s\n", conv_idx2str_style(D_STYLE)));
			continue;
		}
		if (num_cmd == 4 && !strncmp(cmd1, "L", 1) && !strncmp(cmd2, "S", 1)) {
			sscanf(buf, "L%d S%d H%d I%d F%d M%d X%d A%d",
				&D_LEVEL,
				&D_STAT_MIN[0], &D_STAT_MIN[1], &D_STAT_MIN[2], &D_STAT_MIN[3], &D_STAT_MIN[4], &D_STAT_MIN[5], &D_STAT_MIN[6]
			);
			DPRINTF(("[#] level  = %d\n", D_LEVEL));
			for (int i=0; i<NUM_STAT; i++) DPRINTF(("[#] %-4s   = %d\n", conv_idx2str_stat(i), D_STAT_MIN[i]));
		}
		if (num_cmd == 4 && !strcmp(cmd2, "n:")) {
			sscanf(buf, "[ n: %s /_: %s %% ]", cmd1, cmd2);
			xien = conv_str2elem_xien(cmd1);
			D_OPT_RANDOM_RATE = atoi(cmd2);
			DPRINTF(("[#] random = %d\n", D_OPT_RANDOM_RATE));
			continue;
		}
		if (num_cmd == 4 && !strcmp(cmd1, "\")) {
			int lv2;
			sscanf(buf, "\ %s %s %s (Lv%d)܂ŏグ", cmd1, cmd2, cmd3, &lv2);
			if (vec_size && vec_lv2[vec_size-1] >= lv2) continue;
			vec_lv1 [vec_size] = vec_size == 0 ? 2 : vec_lv2[vec_size-1] + 1;
			vec_lv2 [vec_size] = lv2;
			vec_elem[vec_size] = xien | conv_str2elem_stat(cmd1);
			DPRINTF(("[#] assign = %d - %d : %s / %s\n", vec_lv1[vec_size], vec_lv2[vec_size], conv_elem2str_xien(vec_elem[vec_size]), conv_elem2str_stat(vec_elem[vec_size])));
			vec_size++;
			continue;
		}
	}
}

void GAimex_talessimu::imex_vec2log(int &vec_size, int *vec_lv1, int *vec_lv2, ETYPE *vec_elem, char *log)
{
	char stat_buf1[1024];
	char stat_buf2[1024];
	stat_buf2[0] = '\0';
	for (int i=0; i<NUM_STAT; i++) {
		sprintf(stat_buf1, " %s %d", conv_idx2str_stat(i), D_UNIT_STAT[i] / 100);
		strcat(stat_buf2, stat_buf1);
	}

	_strcat(log, "%s^%s", conv_idx2str_chara(D_CHARA), conv_idx2str_style(D_STYLE));
	_strcat(log, "Lv2烉_%d%%", D_OPT_RANDOM_RATE);
	for (int i=0; i<vec_size; i++) {
		_strcat(log, "%ss %s%d(Lv%d)ɂȂ܂%sグ",
			conv_elem2str_xien(vec_elem[i]),
			conv_elem2str_stat(vec_elem[i]),
			D_UNIT_B_STAT(vec_lv2[i])[conv_elem2idx_stat(vec_elem[i])] / 100,
			vec_lv2[i],
			conv_elem2str_stat(vec_elem[i])
		);
	}
	_strcat(log, "cPoint %d", D_UNIT_POINT);
	_strcat(log, "LV %d%s", D_LEVEL, stat_buf2);
}

void GAimex_talessimu::imex_log2vec(int &vec_size, int *vec_lv1, int *vec_lv2, ETYPE *vec_elem, char *log)
{
	char buf[1024];
	char cmd1[1024], cmd2[1024], cmd3[1024], cmd4[1024];
	int num_cmd;

	int lv2 = 0;
	while (_sgets(log, buf)) {
		for (int i=0; i<(int)strlen(buf); i++) if (buf[i] == ',') buf[i] = ' ';
		num_cmd = sscanf(buf, "%s %s %s %s", cmd1, cmd2, cmd3, cmd4);
		DPRINTF(("[%d] %s\n", num_cmd, buf));
		if (num_cmd == 1 && cmd1[0] != 'L') {
			char *pos = strstr(cmd1, "^");
			pos[0] = '\0';
			sprintf(cmd2, "%s/%s", cmd1, pos + 2);
			D_STYLE = conv_str2idx(cmd2);
			D_CHARA = D_STYLE / NUM_STYLE;
			DPRINTF(("[#] chara  = %s\n", conv_idx2str_chara(D_CHARA)));
			DPRINTF(("[#] style  = %s\n", conv_idx2str_style(D_STYLE)));
			continue;
		}
		if (num_cmd == 4 && cmd1[0] == 'L') {
			sscanf(buf, "LV %d STAB %d HACK %d INT %d DEF %d MR %d DEX %d AGI %d",
				&D_LEVEL,
				&D_STAT_MIN[0], &D_STAT_MIN[1], &D_STAT_MIN[2], &D_STAT_MIN[3], &D_STAT_MIN[4], &D_STAT_MIN[5], &D_STAT_MIN[6]
			);
			DPRINTF(("[#] level  = %d\n", D_LEVEL));
			for (int i=0; i<NUM_STAT; i++) DPRINTF(("[#] %-4s   = %d\n", conv_idx2str_stat(i), D_STAT_MIN[i]));
		}
		if (num_cmd == 1 && cmd1[0] == 'L') {
			int tmp;
			sscanf(buf, "Lv%d烉_%d%%", &tmp, &D_OPT_RANDOM_RATE);
			DPRINTF(("[#] random = %d\n", D_OPT_RANDOM_RATE));
		}
		if (num_cmd == 2 && strstr(cmd1, "s")) {
			cmd1[strlen(cmd1)-4] = '\0';
			char *pos1 = strstr(cmd2, "Lv");
			char *pos2 = strstr(cmd2, "Lv");
			char *pos3 = strstr(cmd2, "ɂȂ܂");
			char *pos4 = strstr(cmd2, "グ");
			if (pos1 && !pos2) lv2 = atoi(pos1 + 2);
			pos3 += 10;
			if (pos3 == pos4) continue;
			pos4[0] = '\0';
			if (vec_size && vec_lv2[vec_size-1] >= lv2) continue;
			vec_lv1 [vec_size] = vec_size == 0 ? 2 : vec_lv2[vec_size-1] + 1;
			vec_lv2 [vec_size] = lv2;
			vec_elem[vec_size] = conv_str2elem_xien(cmd1) | conv_str2elem_stat(pos3);
			DPRINTF(("[#] assign = %d - %d : %s / %s\n", vec_lv1[vec_size], vec_lv2[vec_size], conv_elem2str_xien(vec_elem[vec_size]), conv_elem2str_stat(vec_elem[vec_size])));
			vec_size++;
			continue;
		}
	}
}
