#ifndef __GAPARAM_H__
#define __GAPARAM_H__

#include "TWparam.h"

typedef unsigned long ETYPE;

// definition
#define D_CHARA              (m_param->m_chara)
#define D_STYLE              (m_param->m_style)
#define D_LEVEL              (m_param->m_level)
#define D_LEVEL_START        (m_param->m_sim_level_start)
#define D_LEVEL_FINAL        (m_param->m_sim_level_final)
#define D_STAT_MIN           (m_param->m_stat_min)
#define D_STAT_MAX           (m_param->m_stat_max)
#define D_STAT_WEI           (m_param->m_stat_wei)
#define D_STAT_MIN_100       (m_param->m_stat_min_100)
#define D_STAT_MAX_100       (m_param->m_stat_max_100)
#define D_STAT_WEI_HP        (m_param->m_stat_wei_hp)
#define D_STAT_WEI_MP        (m_param->m_stat_wei_mp)
#define D_INIT_USE           (m_param->m_init_use)
#define D_INIT_POINT         (m_param->m_sim_point)
#define D_INIT_STAT          (m_param->m_sim_stat_init_100)
#define D_AVAILABLE_XIEN     (m_param->m_available_xien)
#define D_AVAILABLE_STAT     (m_param->m_available_stat)
#define D_OPT_RANDOM_RATE    (m_param->m_opt_random_rate)
#define D_OPT_PENALTY_XIEN   (m_param->m_opt_penalty_xien_I)
#define D_OPT_PENALTY_STAT   (m_param->m_opt_penalty_stat_I)
#define D_GA_MUTATE_TABLE    (m_param->m_ga_mutate_table)
#define D_SIM_INIT_XIEN      (m_param->m_sim_init_xien)
#define D_SIM_SKILL          (m_param->m_sim_skill)
#define D_TIME_MS_ALL        ((double)m_param->m_proc_time)
#define D_TIME_MS_GENOM      ((double)m_param->m_proc_time / ((double)m_param->m_ga_try_time * m_param->m_ga_generation * m_param->m_ga_unit_total * (m_param->m_sim_level_final - m_param->m_sim_level_start + 1)))

#define IS_OUT_OF_RANGE(param, val1, val2) ((param) < (val1) || (val2) < (param))
#define ASSERT_BY_RANGE_B(errmsg, param, pname, val1, val2) {\
	if (IS_OUT_OF_RANGE((param), (val1), (val2))) {\
		sprintf(errmsg, "%s(%d)%d%d͈̔͂łȂ΂Ȃ܂", (pname), (param), (val1), (val2));\
		return false;\
	}\
}
#define ASSERT_BY_RANGE_G(errmsg, param, pname, val1) {\
	if (IS_OUT_OF_RANGE((param), (val1), 0x7ffffffe)) {\
		sprintf(errmsg, "%s(%d)%dȏłȂ΂Ȃ܂", (pname), (param), (val1));\
		return false;\
	}\
}
#define ASSERT_BY_RANGE_L(errmsg, param, pname, val2) {\
	if (IS_OUT_OF_RANGE((param), 0, (val2))) {\
		sprintf(errmsg, "%s(%d)%dȉłȂ΂Ȃ܂", (pname), (param), (val2));\
		return false;\
	}\
}

class CGAparam : public CTWparam
{
public:
	// LN^[
	int				m_chara;
	int				m_style;
	int				m_level;
	// ڕWXe[^X
	int				m_stat_min[NUM_STAT];
	int				m_stat_max[NUM_STAT];
	int				m_stat_wei[NUM_STAT];
	int				m_stat_min_100[NUM_STAT]; // p[^
	int				m_stat_max_100[NUM_STAT]; // p[^
	double			m_stat_wei_hp;
	double			m_stat_wei_mp;
	// Xe[^X
	bool			m_init_use;
	int				m_init_level;
	int				m_init_point;
	int				m_init_stat[NUM_STAT];
	// LXienEXe[^X
	ETYPE			m_ignored_xien;
	ETYPE			m_ignored_stat;
	ETYPE			m_available_xien; // p[^
	ETYPE			m_available_stat; // p[^
	// ʃIvV
	bool			m_opt_output_fix;
	int				m_opt_random_rate;
	double			m_opt_penalty_xien;
	double			m_opt_penalty_stat;
	int				m_opt_penalty_xien_I; // p[^
	int				m_opt_penalty_stat_I; // p[^
	// GAIvV
	int				m_ga_try_time;
	int				m_ga_generation;
	int				m_ga_unit_elite;
	int				m_ga_unit_twice;
	int				m_ga_unit_unif;
	int				m_ga_unit_swap;
	int				m_ga_unit_total;    // p[^
	int				m_ga_rank_param;
	int				m_ga_rank_tsize;    // p[^
	int*			m_ga_rank_table;    // p[^
	double			m_ga_mutate_rate;
	int				m_ga_mutate_table[MAX_LEVEL + 1]; // p[^
	// V~[Vspp[^p(validate()Ŏ)
	int				m_sim_init_xien;
	int				m_sim_skill[NUM_XIEN][NUM_SKILL];
	int				m_sim_level_start;
	int				m_sim_level_final;
	int				m_sim_point;
	int				m_sim_stat_init_100[NUM_STAT];
	int				m_sim_stat_req[NUM_STAT];
	// V~[Vs
	int				m_proc_time;

	CGAparam() {
		m_ga_rank_table = NULL;
		m_need_point_100 = NULL;
	};
	~CGAparam() {
		if (m_ga_rank_table) delete [] m_ga_rank_table;
		need_point_delete();
	};
	// ϐ̊S
	// V~[V̍ŏɎs邱
	void			initialize();
	void			initialize_stat_minmax(int *stat_min, int *stat_max);
	// p[^`FbN
	// p[^ݒɎs邱
	bool			validate(char *errmsg);

	// Kv|Cge[u
	int				*m_need_point_100;
	inline int		&need_point_100(int lv, int stat_val)
		{ return m_need_point_100[(lv << 16) + stat_val]; };
	void			need_point_new();
	void			need_point_delete();
};

#endif // __GAPARAM_H__
