#ifndef __GAUNIT_H__
#define __GAUNIT_H__

#include "GAparam.h"

// definition
#define NUM_ELEM            (MAX_LEVEL+1)
#define ELEM_STARTBIT_XIEN   0
#define ELEM_STARTBIT_STAT   16
#define ELEM_MASK_XIEN       0x0000ffff
#define ELEM_MASK_STAT       0x7fff0000
#define INDEX_HMSW_MIN       0
#define INDEX_HMSW_MAX       1
#define INDEX_HMSW_L99       2
#define INDEX_HMSW_H99       3
#define INDEX_HMSW_AVG       4

class CGAunit
{
public:
	ETYPE			m_genom[NUM_ELEM];          // `q(x̐sXienƃXe[^X㏸)
	int				m_stat[NUM_STAT];           // ݂̈`qł̃Xe[^X
	int				m_hpmp[2];                  // ݂̈`qłHP/MP
	int				m_point;                    // ݂̈`qł̎c|Cg
	int				m_score;                    // ݂̈`qł̓Kx
	bool			m_evaled;                   // Kx͌vZς݂̒lǂ

	// p[^(ÓIϐ)
	static CGAparam	*m_param;
	// obNAbvf[^(ÓIϐ)
	static ETYPE	m_backup_genom[NUM_ELEM];
	static int		m_backup_stat[NUM_ELEM][NUM_STAT];
	static int		m_backup_hpmp[NUM_ELEM][2];
	static int		m_backup_point[NUM_ELEM];

	// RXgN^
	CGAunit();
	CGAunit(CGAunit &src);
	CGAunit&		operator=(CGAunit &src);
	inline ETYPE&	operator[](int idx) { return m_genom[idx]; };

	// `vf
	ETYPE			element();
	ETYPE			element_mutate(ETYPE elem_base);
	ETYPE			element_xien();
	ETYPE			element_stat();

	// `q
	void			genom_init();
	void			genom_twice(CGAunit &src1, CGAunit &src2);
	void			genom_unif(CGAunit &src1, CGAunit &src2);
	void			genom_swap(CGAunit &src);
	void			genom_mutate();
	void			genom_modify_swap_element(int pos1, int pos2);
	void			genom_modify_swap_band(int pos11, int pos12, int pos21, int pos22);

	// `qA
	void			genomband_import(int &vec_size, int *vec_lv1, int *vec_lv2, ETYPE *vec_elem);
	void			genomband_export(int &vec_size, int *vec_lv1, int *vec_lv2, ETYPE *vec_elem);

	// Kx]
	int				eval(bool do_force = false, int *hmsw = NULL);
	void			eval_init();
	void			eval_backup_save(int &lv);
	void			eval_backup_load(int &lv);
	void			eval_status_auto(int &lv, int *count_xien = NULL);
	void			eval_status_manual(int &lv, int *count_stat = NULL);
	void			eval_check_overflow();
	void			eval_score_point();
	void			eval_score_status();
	void			eval_score_hmsw();
	void			eval_score_penarty();
	void			eval_score_check_xien();
	void			calc_hmsw_distribution(int *hmsw, int *count_xien, int *count_stat);
	void			calc_hmsw_distribution_core(int v_size, int *v_min, int *v_max, int *v_num, double dist_range, int &out_min, int &out_max);
	inline int eval_need_point(int &lv, int &stat)
		{ return m_param->m_sim_stat_req[stat] + m_param->need_point_100(lv, m_stat[stat]); };
//		{ return m_param->m_sim_stat_req[stat] + ((m_stat[stat] * 6711 + lv * 134218) >> 24); }; // Ǖsm

	inline int conv_elem2idx_xien(ETYPE elem)
		{ return (elem & ELEM_MASK_XIEN) >> ELEM_STARTBIT_XIEN; };
	inline int conv_elem2idx_stat(ETYPE elem)
		{ return (elem & ELEM_MASK_STAT) >> ELEM_STARTBIT_STAT; };
	inline ETYPE conv_idx2elem_xien(int index)
		{ return (ETYPE)index << ELEM_STARTBIT_XIEN; };
	inline ETYPE conv_idx2elem_stat(int index)
		{ return (ETYPE)index << ELEM_STARTBIT_STAT; };
};

bool operator==(CGAunit &src1, CGAunit &src2);

// _l
inline int rand_value()
{
	// SFMT
	return (int)(gen_rand32() & 0x7fffffff);
}

// ͈͎w胉_ (0 <= x < range)
inline int rand_range1(int range)
{
	return rand_value() % range;
}

// ͈͎w胉_ (a <= x <= b)
inline int rand_range2(int a, int b)
{
	return a + (rand_value() % (b - a + 1));
}

// 2_
inline bool rand_bool(bool reset = false)
{
	static int rand_bit = 0;
	static int rand_buf = 0;

	if (reset) {
		rand_bit = 0;
		rand_buf = 0;
		return false;
	}

	if (rand_bit == 0) {
		rand_bit = 30;
		rand_buf = rand_value();
	}

	rand_bit--;
	return (rand_buf & (1 << rand_bit)) ? true : false;
}

// 8rbgl
inline int rand_b8()
{
	return rand_value() & 0x000000ff;
}

// 16rbgl
inline int rand_b16()
{
	return rand_value() & 0x0000ffff;
}

// 24rbgl
inline int rand_b24()
{
	return rand_value() & 0x00ffffff;
}

#endif // __GAUNIT_H__
