#ifndef __TWPARAM_H__
#define __TWPARAM_H__

// definition
#define MAX_STATUS		255
#define MAX_LEVEL		255
#define NUM_CHARA		12
#define NUM_STYLE		3
#define NUM_XIEN		26
#define NUM_STAT		7
#define NUM_HMSW		4
#define NUM_SKILL		10
#define NUM_SKILLTBL	63
#define INDEX_S			0
#define INDEX_H			1
#define INDEX_I			2
#define INDEX_F			3
#define INDEX_M			4
#define INDEX_X			5
#define INDEX_A			6
#define INDEX_HP		0
#define INDEX_MP		1
#define INDEX_SP		2
#define INDEX_WT		3

extern int g_tw_style[NUM_CHARA * NUM_STYLE][NUM_STAT * 2 + NUM_HMSW + 3];
extern int g_tw_skill[NUM_SKILLTBL][2 + NUM_SKILL];
extern int g_tw_lvup_auto[NUM_XIEN][NUM_HMSW * 2 + 3];
extern int g_tw_lvup_manual[NUM_STAT][NUM_HMSW + 2];
extern int g_tw_lvup_point[10];

class CTWparam
{
public:
	inline char *chara_name(int chara)              { return         (char *)g_tw_style[chara * 3][NUM_STAT * 2 + NUM_HMSW + 0]; };
	inline char *style_name(int style)              { return         (char *)g_tw_style[style][NUM_STAT * 2 + NUM_HMSW + 1]; };
	inline int   style_xien(int style)              { return str2idx((char *)g_tw_style[style][NUM_STAT * 2 + NUM_HMSW + 2]); };
	inline int   style_stat(int style, int stat)    { return                 g_tw_style[style][NUM_STAT * 0 + stat]; };
	inline int   style_req(int style, int stat)     { return                 g_tw_style[style][NUM_STAT * 1 + stat]; };
	inline int   style_hmsw(int style, int hmsw)    { return                 g_tw_style[style][NUM_STAT * 2 + hmsw]; };
	inline int   skill_chara(int skill)             { return str2idx((char *)g_tw_skill[skill][0]); };
	inline int   skill_xien(int skill)              { return str2idx((char *)g_tw_skill[skill][1]); };
	inline int   skill_level(int skill, int index)  { return                 g_tw_skill[skill][2 + index]; };
	inline char *xien_name(int xien)                { return         (char *)g_tw_lvup_auto[xien][NUM_HMSW * 2 + 2]; };
	inline int   xien_up_fix(int xien)              { return                 g_tw_lvup_auto[xien][NUM_HMSW * 2 + 0]; };
	inline int   xien_up_rnd(int xien)              { return                 g_tw_lvup_auto[xien][NUM_HMSW * 2 + 1]; };
	inline int   xien_hmsw_min(int xien, int hmsw)  { return                 g_tw_lvup_auto[xien][hmsw * 2 + 0]; };
	inline int   xien_hmsw_max(int xien, int hmsw)  { return                 g_tw_lvup_auto[xien][hmsw * 2 + 1]; };
	inline char *stat_name(int stat)                { return         (char *)g_tw_lvup_manual[stat][NUM_HMSW + 0]; };
	inline char *stat_mark(int stat)                { return         (char *)g_tw_lvup_manual[stat][NUM_HMSW + 1]; };
	inline int   stat_hmsw(int stat, int hmsw)      { return                 g_tw_lvup_manual[stat][hmsw]; };
	inline int   lvup_point(int lv)                 { return                 m_lvup_point[lv]; };
	inline int   need_point(int lv, int stat_val)   { return                 m_need_point[lv][stat_val]; };

	CTWparam();
	int          str2idx(char *str);
	char *       idx2str_chara(int _chara, bool use_oldname = false);
	char *       idx2str_style(int _style, bool use_oldname = false);
	int          skill_level_find(int chara, int xien, int index);

	int m_lvup_point[MAX_LEVEL + 1];
	int m_need_point[MAX_LEVEL + 1][MAX_STATUS + 1];
	int m_hmsw_sum_auto[NUM_HMSW][NUM_XIEN];
	int m_hmsw_sum_manual[NUM_HMSW][NUM_STAT];
};

#endif // __TWPARAM_H__
